Index: issm/branches/trunk-jpl-damage/src/modules/matlab/Makefile.am
===================================================================
--- issm/branches/trunk-jpl-damage/src/modules/matlab/Makefile.am	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/modules/matlab/Makefile.am	(revision 12878)
@@ -1,3 +1,3 @@
-INCLUDES = @MATLABINCL@ @PETSCINCL@ @MPIINCL@ @METISINCL@ @TRIANGLEINCL@ @CHACOINCL@ @SCOTCHINCL@ @SHAPELIBINCL@ @BOOSTINCL@ @PYTHONINCL@ @PYTHON_NUMPYINCL@
+INCLUDES = @DAKOTAINCL@ @MATLABINCL@ @PETSCINCL@ @MPIINCL@ @SPOOLESINCL@ @METISINCL@ @TRIANGLEINCL@ @CHACOINCL@ @SCOTCHINCL@ @SHAPELIBINCL@ @BOOSTINCL@ @PYTHONINCL@ @PYTHON_NUMPYINCL@
 EXEEXT=$(MATLABWRAPPEREXT)
 #Bin programs {{{1
@@ -41,5 +41,5 @@
 #}}}
 #Flags and libraries {{{1
-LDADD = ../../c/libISSMCore.a ../../c/libISSMModules.a $(TRIANGLELIB) $(PETSCLIB) $(FLIBS) $(PLAPACKLIB) $(MUMPSLIB) $(SCALAPACKLIB) $(BLACSLIB) $(HYPRELIB) $(MLLIB) $(DAKOTALIB) $(METISLIB) $(CHACOLIB) $(SCOTCHLIB) $(BLASLAPACKLIB) $(MPILIB) $(MATHLIB) $(FORTRANLIB) $(GRAPHICSLIB) $(MULTITHREADINGLIB) $(SHAPELIBLIB) $(GSLLIB)
+LDADD = ../../c/libISSMCore.a ../../c/libISSMModules.a $(TRIANGLELIB) $(PETSCLIB) $(FLIBS) $(PLAPACKLIB) $(SPOOLESLIB) $(MUMPSLIB) $(SUPERLULIB) $(SPAILIB) $(PROMETHEUSLIB) $(PASTIXLIB) $(SCALAPACKLIB) $(BLACSLIB) $(HYPRELIB) $(MLLIB) $(DAKOTALIB) $(METISLIB) $(CHACOLIB) $(SCOTCHLIB) $(BLASLAPACKLIB) $(MPILIB) $(MATHLIB) $(FORTRANLIB) $(GRAPHICSLIB) $(MULTITHREADINGLIB) $(SHAPELIBLIB) $(GSLLIB)
 
 #Triangle library
@@ -50,6 +50,9 @@
 AM_CXXFLAGS +=  -D_HAVE_MATLAB_MODULES_ -D_GNU_SOURCE -fPIC -fno-omit-frame-pointer -pthread 
 LDADD       += $(MEXLIB) ../../c/libISSMMatlab.a 
-
-LDADD       += ../../c/libISSMCore.a ../../c/libISSMModules.a 
+LDADD       += ../../c/libISSMCore.a 
+if CIRCULAR_DEPENDENCIES
+LDADD       += $(TRIANGLELIB) $(PETSCLIB) $(FLIBS) $(PLAPACKLIB) $(SPOOLESLIB) $(MUMPSLIB) $(SUPERLULIB) $(SPAILIB) $(PROMETHEUSLIB) $(PASTIXLIB) $(SCALAPACKLIB) $(BLACSLIB) $(HYPRELIB) $(MLLIB) $(DAKOTALIB) $(METISLIB) $(CHACOLIB) $(SCOTCHLIB) $(BLASLAPACKLIB) $(MPILIB) $(MATHLIB) $(FORTRANLIB) $(GRAPHICSLIB) $(MULTITHREADINGLIB) $(SHAPELIBLIB) $(GSLLIB)
+endif
+LDADD       += ../../c/libISSMModules.a
 
 #Optimization flags:
Index: issm/branches/trunk-jpl-damage/src/modules/python/Makefile.am
===================================================================
--- issm/branches/trunk-jpl-damage/src/modules/python/Makefile.am	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/modules/python/Makefile.am	(revision 12878)
@@ -1,3 +1,3 @@
-INCLUDES = @MATLABINCL@ @PETSCINCL@ @MPIINCL@ @METISINCL@ @TRIANGLEINCL@ @CHACOINCL@ @SCOTCHINCL@ @SHAPELIBINCL@ @BOOSTINCL@ @PYTHONINCL@ @PYTHON_NUMPYINCL@
+INCLUDES = @DAKOTAINCL@ @MATLABINCL@ @PETSCINCL@ @MPIINCL@ @METISINCL@ @TRIANGLEINCL@ @CHACOINCL@ @SCOTCHINCL@ @SHAPELIBINCL@ @BOOSTINCL@ @PYTHONINCL@ @PYTHON_NUMPYINCL@
 EXEEXT=$(PYTHONWRAPPEREXT)
 #Bin programs {{{1
@@ -17,5 +17,5 @@
 #Python part
 AM_LDFLAGS   = $(PYTHONLINK)
-AM_CXXFLAGS +=  -D_HAVE_PYTHON_MODULES_ 
+AM_CXXFLAGS +=  -D_HAVE_PYTHON_MODULES_  -fPIC
 if PYTHON3
 AM_CXXFLAGS +=  -DNPY_NO_DEPRECATED_API 
Index: issm/branches/trunk-jpl-damage/startup.py
===================================================================
--- issm/branches/trunk-jpl-damage/startup.py	(revision 12877)
+++ issm/branches/trunk-jpl-damage/startup.py	(revision 12878)
@@ -22,4 +22,6 @@
 #ISSM path. Go through src/py and load everything we find  that looks like a python file
 for root,dirs,files in os.walk(ISSM_DIR+ '/src/py'):
+	if '.svn' in dirs:
+		dirs.remove('.svn')
 	for file in files:
 		if file.find(".py") != -1:
@@ -31,4 +33,6 @@
 
 for root,dirs,files in os.walk(ISSM_DIR+ '/src/m'):
+	if '.svn' in dirs:
+		dirs.remove('.svn')
 	for file in files:
 		if file.find(".py") != -1:
@@ -64,5 +68,4 @@
 from settings import *
 from solver import *
-from issmtier  import * 
 from ismumps  import * 
 from pairoptions  import * 
@@ -77,6 +80,4 @@
 from stokesoptions import *
 from generic import *
-from none import *
-from none import *
 from hydrology import *
 from miscellaneous import *
Index: issm/branches/trunk-jpl-damage/test/NightlyRun/IdFromString.m
===================================================================
--- issm/branches/trunk-jpl-damage/test/NightlyRun/IdFromString.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/test/NightlyRun/IdFromString.m	(revision 12878)
@@ -22,5 +22,5 @@
 %return if no test found
 if isempty(ids_raw),
-	disp(['No test matches ''' string '' ]);
+	disp(['No test matches ''' string '''' ]);
 	return
 end
Index: issm/branches/trunk-jpl-damage/test/NightlyRun/IdFromString.py
===================================================================
--- issm/branches/trunk-jpl-damage/test/NightlyRun/IdFromString.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/test/NightlyRun/IdFromString.py	(revision 12878)
@@ -0,0 +1,36 @@
+#! /usr/bin/env python
+from IdToName import IdToName
+
+def IdFromString(string):
+	"""
+	IDFROMSTRING - output ids from a given string
+ 
+	    Usage:
+	       ids=IdFromString(string)
+ 
+	    Examples:
+	       ids=IdFromString('Parallel')
+	       ids=IdFromString('79North')
+	"""
+
+	#Check input
+	if not isinstance(string,str):
+		raise TypeError('IdFromString error message: input argument is not a string.')
+
+	#Get the dictionary and scan for matches
+	idnames=IdToName(0)
+	ids=[item[0] for item in idnames.iteritems() if string in item[1]]
+
+	#Return if no test found
+	if not ids:
+		print "No test matches '%s'." % string
+		return ids
+
+	#Display names
+	ids.sort()
+	print "%d tests match '%s':" % (len(ids),string)
+	for id in ids:
+		print "   %d : %s" % (id,idnames[id])
+
+	return ids
+
Index: issm/branches/trunk-jpl-damage/test/NightlyRun/IdToName.py
===================================================================
--- issm/branches/trunk-jpl-damage/test/NightlyRun/IdToName.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/test/NightlyRun/IdToName.py	(revision 12878)
@@ -0,0 +1,193 @@
+#! /usr/bin/env python
+
+def IdToName(id):
+	"""
+	IDTONAME- return name of test
+ 
+	    Usage:
+	       name=IdToName(id)
+	"""
+
+	idname={
+		101 : 'SquareShelfConstrainedDiagM2d',
+		102 : 'SquareShelfConstrainedDiagM3d',
+		103 : 'SquareShelfConstrainedDiagP3d',
+		104 : 'SquareShelfConstrainedDiagS3d',
+		105 : 'SquareShelfConstrainedProg2d',
+		106 : 'SquareShelfConstrainedProg2dDG',
+		107 : 'SquareShelfConstrainedProg3d',
+		108 : 'SquareShelfConstrainedTherStea',
+		109 : 'SquareShelfConstrainedTherTran',
+		110 : 'SquareShelfConstrainedTranM2d',
+		111 : 'SquareShelfConstrainedTranP3d',
+		112 : 'SquareShelfConstrainedSurfSlop2d',
+		113 : 'SquareShelfConstrainedSurfSlope3d',
+		114 : 'SquareShelfConstrainedBedSlop2d',
+		115 : 'SquareShelfConstrainedBedSlop3d',
+		116 : 'SquareShelfConstrainedBalThic2d',
+		117 : 'SquareShelfConstrainedBalThic3d',
+		118 : 'SquareShelfConstrainedBalThic2dDG',
+		119 : 'SquareBamgMesh',
+		120 : 'SquareShelfConstrainedEnthalpyStea',
+		121 : 'SquareShelfConstrainedEnthalpyTran',
+		122 : 'SquareShelfConstrainedTransP3dEnth',
+		201 : 'SquareShelfDiagM2d',
+		202 : 'SquareShelfDiagM3d',
+		203 : 'SquareShelfDiagP3d',
+		204 : 'SquareShelfDiagS3d',
+		205 : 'SquareShelfDiagMP3dPenalties',
+		206 : 'SquareShelfTherStea',
+		207 : 'SquareShelfTherTran',
+		208 : 'SquareShelfTranM2d',
+		209 : 'SquareShelfTranM3d',
+		210 : 'SquareShelfTranP3d',
+		211 : 'SquareShelfTranS3d',
+		212 : 'SquareShelfCMBM2d',
+		213 : 'SquareShelfCMBM3d',
+		214 : 'SquareShelfCMBP3d',
+		215 : 'SquareShelfCMBS3d',
+		216 : 'SquareShelfDiagM2dRift',
+		217 : 'SquareShelfConstrained',
+		218 : 'SquareShelfConstrainedDakotaB',
+		219 : 'SquareShelfDiagMP3dTiling',
+		220 : 'SquareShelfDiagPS3dTiling',
+		221 : 'SquareShelfDiagMS3dTiling',
+		222 : 'SquareShelfDiagM2dTransientIncrHydro',
+		223 : 'SquareShelfDiagM2dTransientIncrNonHydro',
+		224 : 'SquareShelfDiagP3dTransientIncrHydro',
+		225 : 'SquareShelfDiagP3dTransientIncrNonHydro',
+		226 : 'SquareShelfTranCflM2d',
+		227 : 'SquareShelfTranCflP3d',
+		228 : 'SquareShelfTranForceNeg2d',
+		229 : 'SquareShelfTranForcePos2d',
+		230 : 'SquareShelfTranForceNeg3d',
+		231 : 'SquareShelfTranForcePos3d',
+		232 : 'SquareShelfTherTranForcTemp',
+		233 : 'SquareShelfTranP3dForcTemp',
+		234 : 'SquareShelfTranForceNeg2dDakotaSamp',
+   	235 : 'SquareShelfTranForceNeg2dDakotaLocal',
+		301 : 'SquareSheetConstrainedDiagM2d',
+		302 : 'SquareSheetConstrainedDiagH2d',
+		303 : 'SquareSheetConstrainedDiagHM2d',
+		304 : 'SquareSheetConstrainedDiagM3d',
+		305 : 'SquareSheetConstrainedDiagH3d',
+		306 : 'SquareSheetConstrainedDiagHM3d',
+		307 : 'SquareSheetConstrainedDiagP3d',
+		308 : 'SquareSheetConstrainedDiagS3d',
+		309 : 'SquareSheetConstrainedProg2d',
+		310 : 'SquareSheetConstrainedProg2dDG',
+		311 : 'SquareSheetConstrainedProg3d',
+		312 : 'SquareSheetConstrainedTherStea',
+		313 : 'SquareSheetConstrainedTherTran',
+		314 : 'SquareSheetConstrainedTranH2d',
+		315 : 'SquareSheetConstrainedTranH3d',
+		316 : 'SquareSheetConstrainedTranM2d',
+		317 : 'SquareSheetConstrainedTranP3d',
+		318 : 'SquareSheetConstrainedSteaH3d',
+		319 : 'SquareSheetConstrainedCMDragM2d',
+		320 : 'SquareSheetConstrainedCMDragM3d',
+		321 : 'SquareSheetConstrainedCMDragP3d',
+		322 : 'SquareSheetConstrainedCMDragS3d',
+		323 : 'SquareSheetConstrainedTranCflM2d',
+		324 : 'SquareSheetConstrainedTranCflH3d',
+		325 : 'SquareSheetConstrainedEnthalpyStea',
+		326 : 'SquareSheetConstrainedEnthalpyTran',
+		327 : 'SquareSheetConstrainedTransP3dEnth',
+		328 : 'SquareSheetConstrainedSmbGradients2d',
+		329 : 'SquareSheetConstrainedSmbGradients3d',
+		401 : 'SquareSheetShelfDiagM2d',
+		402 : 'SquareSheetShelfDiagM3d',
+		403 : 'SquareSheetShelfDiagP3d',
+		404 : 'SquareSheetShelfDiagS3d',
+		405 : 'SquareSheetShelfDiagMP3dPenalties',
+		406 : 'SquareSheetShelfTherStea',
+		407 : 'SquareSheetShelfTherTran',
+		408 : 'SquareSheetShelfTranM2d',
+		409 : 'SquareSheetShelfTranMP3dPenalties',
+		410 : 'SquareSheetShelfSteaM3d',
+		411 : 'SquareSheetShelfSteaP3d',
+		412 : 'SquareSheetShelfDiadM3dDakota',
+		413 : 'SquareSheetShelfDiadM3dDakotaPart',
+		414 : 'SquareSheetShelfDiadM3dDakotaMassFlux',
+		415 : 'SquareSheetShelfCMDragSteaM3d',
+		416 : 'SquareSheetShelfCMDragSteaP3d',
+		417 : 'SquareSheetShelfDiadM3dDakotaSamp',
+		418 : 'SquareSheetShelfDiadM3dDakotaAreaAverage',
+		419 : 'SquareSheetShelfDiagMP3dTiling',
+		420 : 'SquareSheetShelfDakotaScaledResponse',
+		421 : 'SquareSheetShelfDiagPS3dTiling',
+		422 : 'SquareSheetShelfDiagMS3dTiling',
+		423 : 'RoundSheetShelfGLMigrationM2d',
+		424 : 'SquareSheetShelfGroundingLine2dAgressice',
+		425 : 'SquareSheetShelfGroundingLine2dSoft',
+		426 : 'SquareSheetShelfGroundingLine3dAgressice',
+		427 : 'SquareSheetShelfGroundingLine3dSoft',
+		428 : 'SquareSheetShelfDiagM2dNewton',
+		439 : 'SquareSheetShelfDiagP3dNewton',
+		430 : 'SquareSheetShelfDiagS3dNewton',
+		431 : 'SquareSheetShelfSteaEnthalpyM3d',
+		432 : 'SquareSheetShelfSteaEnthalpyP3d',
+		501 : 'PigDiagM2d',
+		502 : 'PigDiagP3d',
+		503 : 'PigDiagS3d',
+		504 : 'PigTranM2d',
+		505 : 'PigTranM3d',
+		506 : 'PigTranP3d',
+		507 : 'PigTranS3d',
+		508 : 'PigSteaM3d',
+		509 : 'PigSteaP3d',
+		510 : 'PigSteaS3d',
+		511 : 'PigCMBS3d',
+		512 : 'PigCMDragP3d',
+		513 : 'PigCMDragSteaM3d',
+		514 : 'PigBamgMesh',
+		515 : 'PigTherTranSUPG',
+		516 : 'PigTherSteaSUPG',
+		601 : '79NorthProg2d',
+		602 : '79NorthProg2dDG',
+		603 : '79NorthProg3d',
+		604 : '79NorthSurfSlop2d',
+		605 : '79NorthSurfSlop3d',
+		606 : '79NorthBedSlop2d',
+		607 : '79NorthBedSlop3d',
+		608 : '79NorthBalThic2d',
+		609 : '79NorthBalThic2dDG',
+		610 : '79NorthBalThic3d',
+		611 : '79NorthCMBalThic2dCG',
+		612 : '79NorthCMBalThic2dDG',
+		613 : '79NorthCMBalThicVxVy',
+		1101 : 'ISMIPAPattyn',
+		1102 : 'ISMIPAStokes',
+		1103 : 'ISMIPBPattyn',
+		1104 : 'ISMIPBStokes',
+		1105 : 'ISMIPCPattyn',
+		1106 : 'ISMIPCStokes',
+		1107 : 'ISMIPDPattyn',
+		1108 : 'ISMIPDStokes',
+		1109 : 'ISMIPE',
+		1110 : 'ISMIPF',
+		1201 : 'EISMINTMassConservation',
+		1202 : 'EISMINTDiag1',
+		1203 : 'EISMINTDiag2',
+		1204 : 'EISMINTTran2',
+		1205 : 'EISMINTRoundIceSheetStaticHutter',
+		1206 : 'EISMINTRoundIceSheetStaticPattyn',
+		1207 : 'EISMINTRoundIceSheetStaticStokes',
+		1208 : 'EISMINTA',
+		1301 : 'ThermalMelting',
+		1302 : 'ThermalAdvection',
+		1303 : 'ThermalConduction',
+		1304 : 'ThermalGeothermalFlux',
+		1401 : 'AdaptiveMeshRefinement1',
+		1402 : 'AdaptiveMeshRefinement2',
+		1501 : 'SquareShelfTranSawTooth2d',
+		1502 : 'SquareShelfTranSawTooth3d',
+		1601 : 'SquareShelfM2dRotation',
+		1602 : 'SquareSheetShelfP3dRotation',
+	}
+
+	if not id == 0:
+		return idname.get(id,'N/A')
+	else:
+		return idname
+
Index: issm/branches/trunk-jpl-damage/test/NightlyRun/runme.m
===================================================================
--- issm/branches/trunk-jpl-damage/test/NightlyRun/runme.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/test/NightlyRun/runme.m	(revision 12878)
@@ -49,5 +49,5 @@
 if ~ismember(benchmark,{'all','nightly','ismip','eismint','thermal','mesh','validation','tranforcing'})
 	disp('runme warning: benchmark not supported, defaulting to test ''nightly''')
-	benchmark='nighlty';
+	benchmark='nightly';
 end
 % }}}
@@ -87,5 +87,5 @@
 test_ids=intersect(test_ids,list_ids);
 % }}}
-%GET exculde {{{1
+%GET exclude {{{1
 exclude_ids=getfieldvalue(options,'exclude',[]);
 exclude_ids=[exclude_ids];
@@ -126,5 +126,5 @@
 
 			if ~strcmp(oshostname(),'larsen');
-				error(['Nighlty run archives must be saved on "larsen" (hostname is "' oshostname() '")']);
+				error(['Nightly run archives must be saved on "larsen" (hostname is "' oshostname() '")']);
 			end
 			for k=1:length(field_names),
@@ -135,5 +135,5 @@
 			disp(sprintf(['File ./../Archives/' archive_name ' saved\n']));
 
-			%ELSE: CHECK TEST
+		%ELSE: CHECK TEST
 		else,
 
Index: issm/branches/trunk-jpl-damage/test/NightlyRun/runme.py
===================================================================
--- issm/branches/trunk-jpl-damage/test/NightlyRun/runme.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/test/NightlyRun/runme.py	(revision 12878)
@@ -0,0 +1,274 @@
+#! /usr/bin/env python
+import os
+import glob
+import socket
+import numpy
+#import h5py
+import netCDF4
+import sys
+
+def runme(id=None,exclude=None,benchmark='nightly',procedure='check',output='none',rank=1,numprocs=1):
+	"""
+	RUNME - test deck for ISSM nightly runs
+ 
+	    In a test deck directory (tests/Vertification/NightlyRun for example)
+	    The following command will launch all the existing tests:
+	    >>> runme()
+	    To run the tests 101 and 102:
+	    >>> runme(id=[101,102])
+	    etc...
+ 
+	    Available options:
+	       'id'            followed by the list of ids requested
+	       'exclude'       ids to be excluded from the test
+	       'benchmark'     'nightly' (nightly run/ daily run)
+	                       'ismip'  : validation of ismip-hom tests
+	                       'eismint': validation of eismint tests
+	                       'thermal': validation of thermal tests
+	                       'mesh'   : validation of mesh tests
+	                       ...
+	       'procedure'     'check' : run the test (default)
+	                       'update': update the archive
+ 
+	    Usage:
+	       md=runme(varargin);
+ 
+	    Examples:
+	       runme()
+	       runme(exclude=101)
+	       md=runme(id=102,procedure='update')
+	"""
+
+	from parallelrange import parallelrange
+	from IdToName import IdToName
+
+	#Get ISSM_DIR variable
+	ISSM_DIR=os.environ['ISSM_DIR']
+	print 'ISSM_DIR =',ISSM_DIR
+
+	#Process options
+	#GET benchmark {{{1
+	if not benchmark.lower() in ['all','nightly','ismip','eismint','thermal','mesh','validation','tranforcing']:
+		print "runme warning: benchmark '%s' not supported, defaulting to test 'nightly'." % benchmark
+		benchmark='nightly'
+	# }}}
+	#GET procedure {{{1
+	if not procedure.lower() in ['check','update']:
+		print "runme warning: procedure '%s' not supported, defaulting to test 'check'." % procedure
+		procedure='check'
+	# }}}
+	#GET output {{{1
+	if not output.lower() in ['nightly','daily','none']:
+		print "runme warning: output '%s' not supported, defaulting to test 'none'." % output
+		output='none'
+	# }}}
+	#GET RANK and NUMPROCS for multithreaded runs {{{1
+	if (numprocs<rank):
+		numprocs=1
+	# }}}
+
+	print 'id =',id
+	print 'exclude =',exclude
+	print 'benchmark =',benchmark
+	print 'procedure =',procedure
+	print 'output =',output
+	print 'rank =',rank
+	print 'numprocs =',numprocs
+
+	#GET ids  {{{1
+	flist=glob.glob('test*.py')    #File name must start with 'test' and must end by '.py' and must be different than 'test.py'
+	list_ids=[int(file[4:-3]) for file in flist if not file == 'test.py']    #Keep test id only (skip 'test' and '.py')
+	print 'list_ids =',list_ids
+
+	i1,i2=parallelrange(rank,numprocs,len(list_ids))    #Get tests for this cpu only
+	list_ids=list_ids[i1:i2+1]
+	print 'list_ids after parallelrange =',list_ids
+
+	if id:
+		if isinstance(id,list):
+			test_ids=id
+		else:
+			test_ids=[id]
+		test_ids=set(test_ids).intersection(set(list_ids))
+	else:
+		test_ids=set(list_ids)
+#	print 'test_ids after list =',test_ids
+	# }}}
+
+	#GET exclude {{{1
+	if exclude:
+		if isinstance(exclude,list):
+			exclude_ids=exclude
+		else:
+			exclude_ids=[exclude]
+		test_ids=test_ids.difference(set(exclude_ids))
+#	print 'test_ids after exclude =',test_ids
+	# }}}
+
+	#Process Ids according to benchmarks {{{1
+	if   benchmark.lower() == 'nightly':
+		test_ids=test_ids.intersection(set(range(1,1000)))
+	elif benchmark.lower() == 'ismip':
+		test_ids=test_ids.intersection(set(range(1101,1200)))
+	elif benchmark.lower() == 'eismint':
+		test_ids=test_ids.intersection(set(range(1201,1300)))
+	elif benchmark.lower() == 'thermal':
+		test_ids=test_ids.intersection(set(range(1301,1400)))
+	elif benchmark.lower() == 'mesh':
+		test_ids=test_ids.intersection(set(range(1401,1500)))
+	elif benchmark.lower() == 'validation':
+		test_ids=test_ids.intersection(set(range(1001,2000)))
+	elif benchmark.lower() == 'tranforcing':
+		test_ids=test_ids.intersection(set(range(1501,1503)))
+#	print 'test_ids after benchmark =',test_ids
+	test_ids=list(test_ids)
+	test_ids.sort()
+	print 'test_ids after sort =',test_ids
+	# }}}
+
+	#Loop over tests and launch sequence
+	root=os.getcwd()
+	for id in test_ids:
+		try:
+
+			#Execute test
+			os.chdir(root)
+			id_string=IdToName(id)
+			execfile('test'+str(id)+'.py',globals())
+
+			#UPDATE ARCHIVE?
+			archive_name='Archive'+str(id)
+			if procedure.lower() == 'update':
+
+				if not socket.gethostname().lower().split('.')[0] == 'larsen':
+#					raise RuntimeError("Nightly run archives must be saved on 'larsen' (hostname is '"+socket.gethostname()+"').")
+					print "Nightly run archives must be saved on 'larsen' (hostname is '"+socket.gethostname()+"')."
+#				f = h5py.File(os.path.join('..','Archives',archive_name+'.hdf5'),'w')
+				f = netCDF4.Dataset(os.path.join('..','Archives',archive_name+'.nc'),'w')
+				for k,fieldname in enumerate(field_names):
+					field=numpy.array(field_values[k],dtype=float)
+#					f.create_dataset(archive_name+'_field'+str(k),data=field)
+					f.createDimension(archive_name+'_field'+str(k)+'_0',numpy.size(field,0))
+					f.createDimension(archive_name+'_field'+str(k)+'_1',numpy.size(field,1))
+					v = f.createVariable(archive_name+'_field'+str(k),'f8',(archive_name+'_field'+str(k)+'_0',archive_name+'_field'+str(k)+'_1'))
+					v[:] = field
+				f.close()
+				print "File '%s' saved.\n" % os.path.join('..','Archives',archive_name+'.nc')
+
+			#ELSE: CHECK TEST
+			else:
+
+				#load archive
+				if os.path.exists(os.path.join('..','Archives',archive_name+'.nc')):
+#					f = h5py.File(os.path.join('..','Archives',archive_name+'.hdf5'),'r')
+					f = netCDF4.Dataset(os.path.join('..','Archives',archive_name+'.nc'),'r')
+				else:
+					raise IOError("Archive file '"+os.path.join('..','Archives',archive_name+'.nc')+"' does not exist.")
+
+				for k,fieldname in enumerate(field_names):
+
+					try:
+						#Get field and tolerance
+						field=numpy.array(field_values[k],dtype=float)
+#						print 'field =',field
+						tolerance=field_tolerances[k]
+#						print 'tolerance =',tolerance
+
+						#compare to archive
+#						if archive_name+'_field'+str(k) in f:
+#							archive=f[archive_name+'_field'+str(k)][...]
+						if archive_name+'_field'+str(k) in f.variables:
+							archive=f.variables[archive_name+'_field'+str(k)][:]
+						else:
+							raise NameError("Field name '"+archive_name+'_field'+str(k)+"' does not exist in archive file.")
+#						print 'archive =',archive
+						error_diff=numpy.amax(numpy.abs(archive-field),axis=1)/ \
+								   (numpy.amax(numpy.abs(archive),axis=1)+sys.float_info.epsilon)
+#						print 'error_diff =',error_diff
+
+						#disp test result
+						if (error_diff>tolerance):
+							print 'ERROR   difference: %-7.2g > %7.2g test id: %i test name: %s field: %s' % \
+								(error_diff,tolerance,id,id_string,fieldname)
+						else:
+							print 'SUCCESS difference: %-7.2g < %7.2g test id: %i test name: %s field: %s' % \
+								(error_diff,tolerance,id,id_string,fieldname)
+
+					except Exception as me2:
+
+						#something went wrong, print failure message:
+						directory=os.getcwd().split('/')    #  not used?
+						message=me2
+						if   output.lower() == 'nightly':
+							fid=open(os.path.join(ISSM_DIR,'nightlylog','matlaberror.log'), 'a')
+							fid.write('%s' % message)
+							fid.write('\n------------------------------------------------------------------\n')
+							fid.close()
+							print 'FAILURE difference: N/A test id: %i test name: %s field: %s' % (id,id_string,fieldname)
+						elif output.lower() == 'daily':
+							fid=open(os.path.join(ISSM_DIR,'dailylog','matlaberror.log'), 'a')
+							fid.write('%s' % message)
+							fid.write('\n------------------------------------------------------------------\n')
+							fid.close()
+							print 'FAILURE difference: N/A test id: %i test name: %s field: %s' % (id,id_string,fieldname)
+						else:
+							print 'FAILURE difference: N/A test id: %i test name: %s field: %s' % (id,id_string,fieldname)
+							raise RuntimeError(me2)
+
+				f.close()
+
+		except Exception as me:
+
+			#something went wrong, print failure message:
+			directory=os.getcwd().split('/')    #  not used?
+			message=me
+			if   output.lower() == 'nightly':
+				fid=open(os.path.join(ISSM_DIR+'nightlylog','matlaberror.log'), 'a')
+				fid.write('%s' % message)
+				fid.write('\n------------------------------------------------------------------\n')
+				fid.close()
+				print 'FAILURE difference: N/A test id: %i test name: %s field: %s' % (id,id_string,'N/A')
+			elif output.lower() == 'daily':
+				fid=open(os.path.join(ISSM_DIR+'dailylog','matlaberror.log'), 'a')
+				fid.write('%s' % message)
+				fid.write('\n------------------------------------------------------------------\n')
+				fid.close()
+				print 'FAILURE difference: N/A test id: %i test name: %s field: %s' % (id,id_string,'N/A')
+			else:
+				print 'FAILURE difference: N/A test id: %i test name: %s field: %s' % (id,id_string,'N/A')
+				raise RuntimeError(me)
+
+#	#output md if requested
+#	if nargout==1
+#		varargout{1}=md;
+#	end
+
+	return
+
+if __name__ == '__main__':
+	if 'PYTHONSTARTUP' in os.environ:
+		PYTHONSTARTUP=os.environ['PYTHONSTARTUP']
+		print 'PYTHONSTARTUP =',PYTHONSTARTUP
+		if os.path.exists(PYTHONSTARTUP):
+			try:
+				execfile(PYTHONSTARTUP)
+			except Exception as e:
+				print "PYTHONSTARTUP error: ",e
+		else:
+			print "PYTHONSTARTUP file '%s' does not exist." % PYTHONSTARTUP
+
+	import argparse
+	parser = argparse.ArgumentParser(description='RUNME - test deck for ISSM nightly runs')
+	parser.add_argument('-i','--id', nargs='*', type=int, help='followed by the list of ids requested', default=[])
+	parser.add_argument('-e','--exclude', nargs='*', type=int, help='ids to be excluded from the test', default=[])
+	parser.add_argument('-b','--benchmark', help='nightly/ismip/eismint/thermal/mesh/...', default='nightly')
+	parser.add_argument('-p','--procedure', help='check/update', default='check')
+	parser.add_argument('-o','--output', help='nightly/daily/none', default='none')
+	parser.add_argument('-r','--rank', type=int, help='rank', default=1)
+	parser.add_argument('-n','--numprocs', type=int, help='numprocs', default=1)
+	args = parser.parse_args()
+
+	md = runme(args.id, args.exclude, args.benchmark, args.procedure, args.output, args.rank, args.numprocs)
+
+	exit(md)
+
Index: issm/branches/trunk-jpl-damage/test/NightlyRun/test101.m
===================================================================
--- issm/branches/trunk-jpl-damage/test/NightlyRun/test101.m	(revision 12878)
+++ issm/branches/trunk-jpl-damage/test/NightlyRun/test101.m	(revision 12878)
@@ -0,0 +1,22 @@
+md=triangle(model,'../Exp/Square.exp',50000);
+md=setmask(md,'all','');
+md=parameterize(md,'../Par/SquareShelfConstrained.par');
+md=setflowequation(md,'macayeal','all');
+md.cluster=generic('name',oshostname(),'np',3);
+md.diagnostic.requested_outputs=StressTensorEnum;
+md=solve(md,DiagnosticSolutionEnum);
+
+%Fields and tolerances to track changes
+field_names     ={'Vx','Vy','Vel','Pressure',...
+	'StressTensorxx','StressTensoryy','StressTensorxy'};
+field_tolerances={1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13};
+field_values={...
+	(md.results.DiagnosticSolution.Vx),...
+	(md.results.DiagnosticSolution.Vy),...
+	(md.results.DiagnosticSolution.Vel),...
+	(md.results.DiagnosticSolution.Pressure),...
+	(md.results.DiagnosticSolution.StressTensorxx),...
+	(md.results.DiagnosticSolution.StressTensoryy),...
+	(md.results.DiagnosticSolution.StressTensorxy),...
+	};
Index: issm/branches/trunk-jpl-damage/test/NightlyRun/test101.py
===================================================================
--- issm/branches/trunk-jpl-damage/test/NightlyRun/test101.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/test/NightlyRun/test101.py	(revision 12878)
@@ -0,0 +1,24 @@
+from model import *
+from triangle import *
+from setmask import *
+from parameterize import *
+
+md=model()
+md=triangle(md,'../Exp/Square.exp',50000)
+md=setmask(md,'all','')
+md=parameterize(md,'../Par/SquareShelfConstrained.py')
+
+#Fields and tolerances to track changes
+field_names     =['Vx','Vy','Vel','Pressure',\
+	'StressTensorxx','StressTensoryy','StressTensorxy']
+field_tolerances=[1e-13,1e-13,1e-13,1e-13,\
+	1e-13,1e-13,1e-13]
+field_values=[\
+	[md.results.DiagnosticSolution.Vx],\
+	[md.results.DiagnosticSolution.Vy],\
+	[md.results.DiagnosticSolution.Vel],\
+	[md.results.DiagnosticSolution.Pressure],\
+	[md.results.DiagnosticSolution.StressTensorxx],\
+	[md.results.DiagnosticSolution.StressTensoryy],\
+	[md.results.DiagnosticSolution.StressTensorxy],\
+	]
Index: issm/branches/trunk-jpl-damage/test/NightlyRun/test102.m
===================================================================
--- issm/branches/trunk-jpl-damage/test/NightlyRun/test102.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/test/NightlyRun/test102.m	(revision 12878)
@@ -1,22 +1,18 @@
-md=triangle(model,'../Exp/Square.exp',50000);
+md=triangle(model,'../Exp/Square.exp',180000);
 md=setmask(md,'all','');
 md=parameterize(md,'../Par/SquareShelfConstrained.par');
+md=extrude(md,3,2);
 md=setflowequation(md,'macayeal','all');
 md.cluster=generic('name',oshostname(),'np',3);
-md.diagnostic.requested_outputs=StressTensorEnum;
 md=solve(md,DiagnosticSolutionEnum);
 
 %Fields and tolerances to track changes
-field_names     ={'Vx','Vy','Vel','Pressure',...
-	'StressTensorxx','StressTensoryy','StressTensorxy'};
-field_tolerances={1e-13,1e-13,1e-13,1e-13,...
-	1e-13,1e-13,1e-13};
+field_names     ={'Vx','Vy','Vz','Vel','Pressure'};
+field_tolerances={1e-13,1e-13,1e-13,1e-13,1e-13};
 field_values={...
 	(md.results.DiagnosticSolution.Vx),...
 	(md.results.DiagnosticSolution.Vy),...
+	(md.results.DiagnosticSolution.Vz),...
 	(md.results.DiagnosticSolution.Vel),...
 	(md.results.DiagnosticSolution.Pressure),...
-	(md.results.DiagnosticSolution.StressTensorxx),...
-	(md.results.DiagnosticSolution.StressTensoryy),...
-	(md.results.DiagnosticSolution.StressTensorxy),...
 	};
Index: issm/branches/trunk-jpl-damage/test/NightlyRun/test103.m
===================================================================
--- issm/branches/trunk-jpl-damage/test/NightlyRun/test103.m	(revision 12878)
+++ issm/branches/trunk-jpl-damage/test/NightlyRun/test103.m	(revision 12878)
@@ -0,0 +1,27 @@
+md=triangle(model,'../Exp/Square.exp',180000);
+md=setmask(md,'all','');
+md=parameterize(md,'../Par/SquareShelfConstrained.par');
+md=extrude(md,3,2);
+md=setflowequation(md,'pattyn','all');
+md.cluster=generic('name',oshostname(),'np',3);
+md.diagnostic.requested_outputs=StressTensorEnum;
+md=solve(md,DiagnosticSolutionEnum);
+
+%Fields and tolerances to track changes
+field_names     ={'Vx','Vy','Vz','Vel','Pressure',...
+	'StressTensorxx','StressTensoryy','StressTensorzz','StressTensorxy','StressTensorxz','StressTensoryz'};
+field_tolerances={1e-09,1e-09,1e-09,1e-09,1e-09,...
+	1e-09,1e-09,1e-09,1e-09,1e-09,1e-09};
+field_values={...
+	(md.results.DiagnosticSolution.Vx),...
+	(md.results.DiagnosticSolution.Vy),...
+	(md.results.DiagnosticSolution.Vz),...
+	(md.results.DiagnosticSolution.Vel),...
+	(md.results.DiagnosticSolution.Pressure),...
+	(md.results.DiagnosticSolution.StressTensorxx),...
+	(md.results.DiagnosticSolution.StressTensoryy),...
+	(md.results.DiagnosticSolution.StressTensorzz),...
+	(md.results.DiagnosticSolution.StressTensorxy),...
+	(md.results.DiagnosticSolution.StressTensorxz),...
+	(md.results.DiagnosticSolution.StressTensoryz),...
+	};
Index: issm/branches/trunk-jpl-damage/test/NightlyRun/test104.m
===================================================================
--- issm/branches/trunk-jpl-damage/test/NightlyRun/test104.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/test/NightlyRun/test104.m	(revision 12878)
@@ -3,5 +3,5 @@
 md=parameterize(md,'../Par/SquareShelfConstrained.par');
 md=extrude(md,3,2);
-md=setflowequation(md,'macayeal','all');
+md=setflowequation(md,'stokes','all');
 md.cluster=generic('name',oshostname(),'np',3);
 md=solve(md,DiagnosticSolutionEnum);
@@ -9,5 +9,5 @@
 %Fields and tolerances to track changes
 field_names     ={'Vx','Vy','Vz','Vel','Pressure'};
-field_tolerances={1e-13,1e-13,1e-13,1e-13,1e-13};
+field_tolerances={1e-08,1e-08,1e-07,1e-08,1e-08};
 field_values={...
 	(md.results.DiagnosticSolution.Vx),...
Index: issm/branches/trunk-jpl-damage/test/NightlyRun/test105.m
===================================================================
--- issm/branches/trunk-jpl-damage/test/NightlyRun/test105.m	(revision 12878)
+++ issm/branches/trunk-jpl-damage/test/NightlyRun/test105.m	(revision 12878)
@@ -0,0 +1,13 @@
+md=triangle(model,'../Exp/Square.exp',150000);
+md=setmask(md,'all','');
+md=parameterize(md,'../Par/SquareShelfConstrained.par');
+md=setflowequation(md,'macayeal','all');
+md.cluster=generic('name',oshostname(),'np',3);
+md=solve(md,PrognosticSolutionEnum);
+
+%Fields and tolerances to track changes
+field_names     ={'Thickness'};
+field_tolerances={1e-13};
+field_values={...
+	(md.results.PrognosticSolution.Thickness),...
+	};
